
  
#include "spi.h"


static __IO uint32_t  SPITimeout = SPIT_LONG_TIMEOUT;   

static uint16_t SPI_TIMEOUT_UserCallback(uint8_t errorCode);

 /**
  * @brief  SPI_FLASHʼ
  * @param  
  * @retval 
  */
void SPI_FLASH_Init(void)
{
  SPI_InitTypeDef  SPI_InitStructure;
  GPIO_InitTypeDef GPIO_InitStructure;
  
  /* ʹ FLASH_SPI GPIO ʱ */
  /*!< SPI_FLASH_SPI_CS_GPIO, SPI_FLASH_SPI_MOSI_GPIO, 
       SPI_FLASH_SPI_MISO_GPIO,SPI_FLASH_SPI_SCK_GPIO ʱʹ */
  RCC_AHB1PeriphClockCmd (FLASH_SPI_SCK_GPIO_CLK | FLASH_SPI_MISO_GPIO_CLK|FLASH_SPI_MOSI_GPIO_CLK|FLASH_CS_GPIO_CLK, ENABLE);

  /*!< SPI_FLASH_SPI ʱʹ */
  FLASH_SPI_CLK_INIT(FLASH_SPI_CLK, ENABLE);
 
  //Ÿ
  GPIO_PinAFConfig(FLASH_SPI_SCK_GPIO_PORT,FLASH_SPI_SCK_PINSOURCE,FLASH_SPI_SCK_AF); 
	GPIO_PinAFConfig(FLASH_SPI_MISO_GPIO_PORT,FLASH_SPI_MISO_PINSOURCE,FLASH_SPI_MISO_AF); 
	GPIO_PinAFConfig(FLASH_SPI_MOSI_GPIO_PORT,FLASH_SPI_MOSI_PINSOURCE,FLASH_SPI_MOSI_AF); 
  
  /*!<  SPI_FLASH_SPI : SCK */
  GPIO_InitStructure.GPIO_Pin = FLASH_SPI_SCK_PIN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;  
  
  GPIO_Init(FLASH_SPI_SCK_GPIO_PORT, &GPIO_InitStructure);
  
	/*!<  SPI_FLASH_SPI : MISO */
  GPIO_InitStructure.GPIO_Pin = FLASH_SPI_MISO_PIN;
  GPIO_Init(FLASH_SPI_MISO_GPIO_PORT, &GPIO_InitStructure);
  
	/*!<  SPI_FLASH_SPI : MOSI */
  GPIO_InitStructure.GPIO_Pin = FLASH_SPI_MOSI_PIN;
  GPIO_Init(FLASH_SPI_MOSI_GPIO_PORT, &GPIO_InitStructure);  

	/*!<  SPI_FLASH_SPI : CS */
  GPIO_InitStructure.GPIO_Pin = FLASH_CS_PIN;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_Init(FLASH_CS_GPIO_PORT, &GPIO_InitStructure);

  /* ֹͣź FLASH: CSŸߵƽ*/
  SPI_FLASH_CS_HIGH();

  /* FLASH_SPI ģʽ */
  // FLASHоƬ ֧SPIģʽ0ģʽ3ݴCPOL CPHA
  SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
  SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
  SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
  SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
  SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
  SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_4;
  SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
  SPI_InitStructure.SPI_CRCPolynomial = 7;
  SPI_Init(FLASH_SPI, &SPI_InitStructure);

  /* ʹ FLASH_SPI  */
  SPI_Cmd(FLASH_SPI, ENABLE);

}

 /**
  * @brief  FLASH
  * @param  SectorAddrҪַ
  * @retval 
  */
void SPI_FLASH_SectorErase(u32 SectorAddr)
{
  /* FLASHдʹ */
  SPI_FLASH_WriteEnable();
  SPI_FLASH_WaitForWriteEnd();
  /*  */
  /* ѡFLASH: CS͵ƽ */
  SPI_FLASH_CS_LOW();
  /* ָ*/
  SPI_FLASH_SendByte(W25X_SectorErase);
  /*Ͳַĸλ*/
  SPI_FLASH_SendByte((SectorAddr & 0xFF0000) >> 16);
  /* Ͳַλ */
  SPI_FLASH_SendByte((SectorAddr & 0xFF00) >> 8);
  /* Ͳַĵλ */
  SPI_FLASH_SendByte(SectorAddr & 0xFF);
  /* ֹͣź FLASH: CS ߵƽ */
  SPI_FLASH_CS_HIGH();
  /* ȴ*/
  SPI_FLASH_WaitForWriteEnd();
}


 /**
  * @brief  FLASHƬ
  * @param  
  * @retval 
  */
void SPI_FLASH_BulkErase(void)
{
  /* FLASHдʹ */
  SPI_FLASH_WriteEnable();

  /*  Erase */
  /* ѡFLASH: CS͵ƽ */
  SPI_FLASH_CS_LOW();
  /* ָ*/
  SPI_FLASH_SendByte(W25X_ChipErase);
  /* ֹͣź FLASH: CS ߵƽ */
  SPI_FLASH_CS_HIGH();

  /* ȴ*/
  SPI_FLASH_WaitForWriteEnd();
}



 /**
  * @brief  FLASHҳдݣñдǰҪȲ
  * @param	pBufferҪдݵָ
  * @param WriteAddrдַ
  * @param  NumByteToWriteдݳȣСڵSPI_FLASH_PerWritePageSize
  * @retval 
  */
void SPI_FLASH_PageWrite(u8* pBuffer, u32 WriteAddr, u16 NumByteToWrite)
{
  /* FLASHдʹ */
  SPI_FLASH_WriteEnable();

  /* ѡFLASH: CS͵ƽ */
  SPI_FLASH_CS_LOW();
  /* дҳдָ*/
  SPI_FLASH_SendByte(W25X_PageProgram);
  /*дַĸλ*/
  SPI_FLASH_SendByte((WriteAddr & 0xFF0000) >> 16);
  /*дַλ*/
  SPI_FLASH_SendByte((WriteAddr & 0xFF00) >> 8);
  /*дַĵλ*/
  SPI_FLASH_SendByte(WriteAddr & 0xFF);

  if(NumByteToWrite > SPI_FLASH_PerWritePageSize)
  {
     NumByteToWrite = SPI_FLASH_PerWritePageSize;
     FLASH_ERROR("SPI_FLASH_PageWrite too large!");
  }

  /* д*/
  while (NumByteToWrite--)
  {
    /* ͵ǰҪдֽ */
    SPI_FLASH_SendByte(*pBuffer);
    /* ָһֽ */
    pBuffer++;
  }

  /* ֹͣź FLASH: CS ߵƽ */
  SPI_FLASH_CS_HIGH();

  /* ȴд*/
  SPI_FLASH_WaitForWriteEnd();
}


 /**
  * @brief  FLASHдݣñдǰҪȲ
  * @param	pBufferҪдݵָ
  * @param  WriteAddrдַ
  * @param  NumByteToWriteдݳ
  * @retval 
  */
void SPI_FLASH_BufferWrite(u8* pBuffer, u32 WriteAddr, u16 NumByteToWrite)
{
  u8 NumOfPage = 0, NumOfSingle = 0, Addr = 0, count = 0, temp = 0;
	
	/*mod࣬writeAddrSPI_FLASH_PageSizeAddrֵΪ0*/
  Addr = WriteAddr % SPI_FLASH_PageSize;
	
	/*countֵպÿԶ뵽ҳַ*/
  count = SPI_FLASH_PageSize - Addr;	
	/*Ҫдҳ*/
  NumOfPage =  NumByteToWrite / SPI_FLASH_PageSize;
	/*mod࣬ʣ಻һҳֽ*/
  NumOfSingle = NumByteToWrite % SPI_FLASH_PageSize;

	 /* Addr=0,WriteAddr պðҳ aligned  */
  if (Addr == 0) 
  {
		/* NumByteToWrite < SPI_FLASH_PageSize */
    if (NumOfPage == 0) 
    {
      SPI_FLASH_PageWrite(pBuffer, WriteAddr, NumByteToWrite);
    }
    else /* NumByteToWrite > SPI_FLASH_PageSize */
    {
			/*Ȱҳд*/
      while (NumOfPage--)
      {
        SPI_FLASH_PageWrite(pBuffer, WriteAddr, SPI_FLASH_PageSize);
        WriteAddr +=  SPI_FLASH_PageSize;
        pBuffer += SPI_FLASH_PageSize;
      }
			
			/*жĲһҳݣд*/
      SPI_FLASH_PageWrite(pBuffer, WriteAddr, NumOfSingle);
    }
  }
	/* ַ SPI_FLASH_PageSize   */
  else 
  {
		/* NumByteToWrite < SPI_FLASH_PageSize */
    if (NumOfPage == 0) 
    {
			/*ǰҳʣcountλñNumOfSingleСд*/
      if (NumOfSingle > count) 
      {
        temp = NumOfSingle - count;
				
				/*дǰҳ*/
        SPI_FLASH_PageWrite(pBuffer, WriteAddr, count);
        WriteAddr +=  count;
        pBuffer += count;
				
				/*дʣ*/
        SPI_FLASH_PageWrite(pBuffer, WriteAddr, temp);
      }
      else /*ǰҳʣcountλдNumOfSingle*/
      {				
        SPI_FLASH_PageWrite(pBuffer, WriteAddr, NumByteToWrite);
      }
    }
    else /* NumByteToWrite > SPI_FLASH_PageSize */
    {
			/*ַcountֿ*/
      NumByteToWrite -= count;
      NumOfPage =  NumByteToWrite / SPI_FLASH_PageSize;
      NumOfSingle = NumByteToWrite % SPI_FLASH_PageSize;

      SPI_FLASH_PageWrite(pBuffer, WriteAddr, count);
      WriteAddr +=  count;
      pBuffer += count;
			
			/*ҳд*/
      while (NumOfPage--)
      {
        SPI_FLASH_PageWrite(pBuffer, WriteAddr, SPI_FLASH_PageSize);
        WriteAddr +=  SPI_FLASH_PageSize;
        pBuffer += SPI_FLASH_PageSize;
      }
			/*жĲһҳݣд*/
      if (NumOfSingle != 0)
      {
        SPI_FLASH_PageWrite(pBuffer, WriteAddr, NumOfSingle);
      }
    }
  }
}

 /**
  * @brief  ȡFLASH
  * @param 	pBuffer洢ݵָ
  * @param   ReadAddrȡַ
  * @param   NumByteToReadȡݳ
  * @retval 
  */
void SPI_FLASH_BufferRead(u8* pBuffer, u32 ReadAddr, u16 NumByteToRead)
{
  /* ѡFLASH: CS͵ƽ */
  SPI_FLASH_CS_LOW();

  /*   ָ */
  SPI_FLASH_SendByte(W25X_ReadData);

  /*   ַλ */
  SPI_FLASH_SendByte((ReadAddr & 0xFF0000) >> 16);
  /*   ַλ */
  SPI_FLASH_SendByte((ReadAddr& 0xFF00) >> 8);
  /*   ַλ */
  SPI_FLASH_SendByte(ReadAddr & 0xFF);
  
	/* ȡ */
  while (NumByteToRead--)
  {
    /* ȡһֽ*/
    *pBuffer = SPI_FLASH_SendByte(Dummy_Byte);
    /* ָһֽڻ */
    pBuffer++;
  }

  /* ֹͣź FLASH: CS ߵƽ */
  SPI_FLASH_CS_HIGH();
}


 /**
  * @brief  ȡFLASH ID
  * @param 	
  * @retval FLASH ID
  */
u32 SPI_FLASH_ReadID(void)
{
  u32 Temp = 0, Temp0 = 0, Temp1 = 0, Temp2 = 0;

  /* ʼͨѶCS͵ƽ */
  SPI_FLASH_CS_LOW();

  /* JEDECָȡID */
  SPI_FLASH_SendByte(W25X_JedecDeviceID);

  /* ȡһֽ */
  Temp0 = SPI_FLASH_SendByte(Dummy_Byte);

  /* ȡһֽ */
  Temp1 = SPI_FLASH_SendByte(Dummy_Byte);

  /* ȡһֽ */
  Temp2 = SPI_FLASH_SendByte(Dummy_Byte);

  /* ֹͣͨѶCSߵƽ */
  SPI_FLASH_CS_HIGH();

	/*Ϊķֵ*/
  Temp = (Temp0 << 16) | (Temp1 << 8) | Temp2;

  return Temp;
}

 /**
  * @brief  ȡFLASH Device ID
  * @param 	
  * @retval FLASH Device ID
  */
u32 SPI_FLASH_ReadDeviceID(void)
{
  u32 Temp = 0;

  /* Select the FLASH: Chip Select low */
  SPI_FLASH_CS_LOW();

  /* Send "RDID " instruction */
  SPI_FLASH_SendByte(W25X_DeviceID);
  SPI_FLASH_SendByte(Dummy_Byte);
  SPI_FLASH_SendByte(Dummy_Byte);
  SPI_FLASH_SendByte(Dummy_Byte);
  
  /* Read a byte from the FLASH */
  Temp = SPI_FLASH_SendByte(Dummy_Byte);

  /* Deselect the FLASH: Chip Select high */
  SPI_FLASH_CS_HIGH();

  return Temp;
}
/*******************************************************************************
* Function Name  : SPI_FLASH_StartReadSequence
* Description    : Initiates a read data byte (READ) sequence from the Flash.
*                  This is done by driving the /CS line low to select the device,
*                  then the READ instruction is transmitted followed by 3 bytes
*                  address. This function exit and keep the /CS line low, so the
*                  Flash still being selected. With this technique the whole
*                  content of the Flash is read with a single READ instruction.
* Input          : - ReadAddr : FLASH's internal address to read from.
* Output         : None
* Return         : None
*******************************************************************************/
void SPI_FLASH_StartReadSequence(u32 ReadAddr)
{
  /* Select the FLASH: Chip Select low */
  SPI_FLASH_CS_LOW();

  /* Send "Read from Memory " instruction */
  SPI_FLASH_SendByte(W25X_ReadData);

  /* Send the 24-bit address of the address to read from -----------------------*/
  /* Send ReadAddr high nibble address byte */
  SPI_FLASH_SendByte((ReadAddr & 0xFF0000) >> 16);
  /* Send ReadAddr medium nibble address byte */
  SPI_FLASH_SendByte((ReadAddr& 0xFF00) >> 8);
  /* Send ReadAddr low nibble address byte */
  SPI_FLASH_SendByte(ReadAddr & 0xFF);
}


 /**
  * @brief  ʹSPIȡһֽڵ
  * @param  
  * @retval ؽյ
  */
u8 SPI_FLASH_ReadByte(void)
{
  return (SPI_FLASH_SendByte(Dummy_Byte));
}


 /**
  * @brief  ʹSPIһֽڵ
  * @param  byteҪ͵
  * @retval ؽյ
  */
u8 SPI_FLASH_SendByte(u8 byte)
{
  SPITimeout = SPIT_FLAG_TIMEOUT;

  /* ȴͻΪգTXE¼ */
  while (SPI_I2S_GetFlagStatus(FLASH_SPI, SPI_I2S_FLAG_TXE) == RESET)
   {
    if((SPITimeout--) == 0) return SPI_TIMEOUT_UserCallback(0);
   }

  /* дݼĴҪдд뷢ͻ */
  SPI_I2S_SendData(FLASH_SPI, byte);

  SPITimeout = SPIT_FLAG_TIMEOUT;

  /* ȴջǿգRXNE¼ */
  while (SPI_I2S_GetFlagStatus(FLASH_SPI, SPI_I2S_FLAG_RXNE) == RESET)
   {
    if((SPITimeout--) == 0) return SPI_TIMEOUT_UserCallback(1);
   }

  /* ȡݼĴȡջ */
  return SPI_I2S_ReceiveData(FLASH_SPI);
}

/*******************************************************************************
* Function Name  : SPI_FLASH_SendHalfWord
* Description    : Sends a Half Word through the SPI interface and return the
*                  Half Word received from the SPI bus.
* Input          : Half Word : Half Word to send.
* Output         : None
* Return         : The value of the received Half Word.
*******************************************************************************/
u16 SPI_FLASH_SendHalfWord(u16 HalfWord)
{
  
  SPITimeout = SPIT_FLAG_TIMEOUT;

  /* Loop while DR register in not emplty */
  while (SPI_I2S_GetFlagStatus(FLASH_SPI, SPI_I2S_FLAG_TXE) == RESET)
  {
    if((SPITimeout--) == 0) return SPI_TIMEOUT_UserCallback(2);
   }

  /* Send Half Word through the FLASH_SPI peripheral */
  SPI_I2S_SendData(FLASH_SPI, HalfWord);

  SPITimeout = SPIT_FLAG_TIMEOUT;

  /* Wait to receive a Half Word */
  while (SPI_I2S_GetFlagStatus(FLASH_SPI, SPI_I2S_FLAG_RXNE) == RESET)
   {
    if((SPITimeout--) == 0) return SPI_TIMEOUT_UserCallback(3);
   }
  /* Return the Half Word read from the SPI bus */
  return SPI_I2S_ReceiveData(FLASH_SPI);
}


 /**
  * @brief  FLASH дʹ 
  * @param  none
  * @retval none
  */
void SPI_FLASH_WriteEnable(void)
{
  /* ͨѶʼCS */
  SPI_FLASH_CS_LOW();

  /* дʹ*/
  SPI_FLASH_SendByte(W25X_WriteEnable);

  /*ͨѶCS */
  SPI_FLASH_CS_HIGH();
}

 /**
  * @brief  ȴWIP(BUSY)־0ȴFLASHڲд
  * @param  none
  * @retval none
  */
void SPI_FLASH_WaitForWriteEnd(void)
{
  u8 FLASH_Status = 0;

  /* ѡ FLASH: CS  */
  SPI_FLASH_CS_LOW();

  /*  ״̬Ĵ  */
  SPI_FLASH_SendByte(W25X_ReadStatusReg);

  SPITimeout = SPIT_FLAG_TIMEOUT;
  /* FLASHæµȴ */
  do
  {
    /* ȡFLASHоƬ״̬Ĵ */
    FLASH_Status = SPI_FLASH_SendByte(Dummy_Byte);	 

    {
      if((SPITimeout--) == 0) 
      {
        SPI_TIMEOUT_UserCallback(4);
        return;
      }
    } 
  }
  while ((FLASH_Status & WIP_Flag) == SET); /* д־ */

  /* ֹͣź  FLASH: CS  */
  SPI_FLASH_CS_HIGH();
}


//ģʽ
void SPI_Flash_PowerDown(void)   
{ 
  /* ѡ FLASH: CS  */
  SPI_FLASH_CS_LOW();

  /*    */
  SPI_FLASH_SendByte(W25X_PowerDown);

  /* ֹͣź  FLASH: CS  */
  SPI_FLASH_CS_HIGH();
}   

//
void SPI_Flash_WAKEUP(void)   
{
  /*ѡ FLASH: CS  */
  SPI_FLASH_CS_LOW();

  /*  ϵ  */
  SPI_FLASH_SendByte(W25X_ReleasePowerDown);

  /* ֹͣź FLASH: CS  */
  SPI_FLASH_CS_HIGH();                   //ȴTRES1
}   


/**
  * @brief  ȴʱص
  * @param  None.
  * @retval None.
  */
static  uint16_t SPI_TIMEOUT_UserCallback(uint8_t errorCode)
{
  /* ȴʱĴ,Ϣ */
  FLASH_ERROR("SPI ȴʱ!errorCode = %d",errorCode);
  return 0;
}
   
/*********************************************END OF FILE**********************/
